/**
 * COMP 401 Fall 2017 -- Recitation 10 November 2017
 * 
 * Copyright (C) 2017, Alex Blate. All Rights Reserved.
 */
package recitations.recitation11;

import java.util.Collection;
//import java.util.Iterator;

public abstract class AbstractQueue<T> implements SimpleQueue<T> {

	public AbstractQueue() {
	};

	/**
	 * Element e is added to the tail/end of the queue
	 * 
	 * @param e
	 */
	@Override
	public abstract void enqueue(T e);

	/**
	 * The first element in the queue is dequeud and returned.
	 * 
	 * @return
	 */
	@Override
	public abstract T dequeue();

	/**
	 * @return the value of the first element in the queue. The queue is not
	 *         modified.
	 */
	@Override
	public abstract T head();

	@Override
	public abstract int size();

	@Override
	public boolean isEmpty() {
		return this.size() == 0;
	}

	@Override
	public void clear() {
		while (size() > 0) {
			this.dequeue();
		}
		assert isEmpty() : "size non-zero after clear()";
	}

	/**
	 * Add the contents of elements to the queue. The
	 * elements are pushed onto the queue in sequential order.
	 * 
	 * @param elements
	 */
	@Override
	public void enqueueAll(T[] elements) {
		if (elements != null) {
			int oldSize = size();
			for (T e : elements) {
				this.enqueue(e);
			}
			assert (oldSize + elements.length) == size() : "Unexpected size after addAll()";
		}
	}

	public <C extends Collection<T>> void enqueueAll(C coll) {
		coll.forEach(u -> this.enqueue(u));

		//		Equivalent to:		
		//		 
		//		java.util.Iterator<T> it = coll.iterator();
		//		 while(it.hasNext()) {
		//			 this.enqueue(it.next());
		//		 }
	}

}
