/**
 * COMP 401 Fall 2017 -- Recitation 10 November 2017
 * 
 * Copyright (C) 2017, Alex Blate. All Rights Reserved.
 */
package recitations.recitation11;

import java.util.Arrays;
import java.util.Deque;
import java.util.LinkedList;
import java.util.NoSuchElementException;

public class BoundedQueue<T> implements CheckedQueue<T> {

	protected final int	capacity;
	//Woah, what's a Deque?
	protected final Deque<T>			queue;

	public BoundedQueue(int capacity) {
		if (capacity <= 0) {
			throw new IllegalArgumentException("Capacity must be positive");
		}

		this.capacity = capacity;
		queue = new LinkedList<T>();

	}


	@Override
	public void enqueue(T e) throws QueueFullException {
		if (size() >= capacity) {
			throw new QueueFullException("Exceeded capacity " + capacity);
		} else if (e == null) {
			throw new IllegalArgumentException(new NullPointerException("Cannot insert null into queue"));
		} else {
			queue.add(e);
		}
	}


	@Override
	public T dequeue() {
		try {
			return queue.removeFirst();
		} catch (NoSuchElementException ex) {
			throw new QueueEmptyException("Empty Queue", ex);
		}
	}


	@Override
	public T head() {
		try {
			return queue.getFirst();
		} catch (NoSuchElementException ex) {
			throw new QueueEmptyException("Empty Queue", ex);
		}
	}


	@Override
	public int size() {
		return this.queue.size();
	}


	@Override
	public boolean isEmpty() {
		return queue.isEmpty();
	}


	@Override
	public void clear() {
		queue.clear();
	}


	@Override
	public void enqueueAll(T[] elements) throws QueueFullException {
		if (null != elements) {
			if (queue.size() + elements.length <= capacity) {
				queue.addAll(queue);
			} else {
				throw new QueueFullException();
			}
		}

	}

	@Override
	public String toString() {
		StringBuffer res = new StringBuffer();
		res.append("Bounded Queue capaicty= ").append(capacity);
		res.append(" size=").append(size()).append(" ");
		res.append(Arrays.toString(queue.toArray()));

		return res.toString();

	}

}
