package recitations.recitation11;

import java.util.Objects;

public class DropTailBoundedQueue<T> extends AbstractQueue<T> {

	protected final BoundedQueue<T> queue;

	public DropTailBoundedQueue(int capacity) {
		queue = new BoundedQueue<T>(capacity);
	}

	public DropTailBoundedQueue(BoundedQueue<T> other) {
		Objects.requireNonNull(other);
		queue=other;
	}
	

	@Override
	public T dequeue() {
		return queue.dequeue();
	}

	@Override
	public void enqueue(T e) {
		try {
			queue.enqueue(e);
		} catch (QueueFullException ex) {
			//ignore (drop tail semantic)
		}

	}

	@Override
	public T head() {
		return queue.head();
	}

	@Override
	public int size() {
		return queue.size();
	}

	@Override	
	public String toString() {
		return queue.toString();
	
	}

}
