/**
 * COMP 401 Fall 2017 -- Recitation 10 November 2017
 * 
 * Copyright (C) 2017, Alex Blate. All Rights Reserved.
 */
package recitations.recitation11;


public class ListNode<T> {
	
	protected ListNode<T> prev=null;
	protected ListNode<T> next=null;
	protected T value=null;
	
	public ListNode() {};
	
	public ListNode(T value) {
		this.setValue(value);
	}
	
	public ListNode(T value, ListNode<T> prev, ListNode<T> next) {
		this(value);
		setPrev(prev);
		setNext(next);
	}
	
	public ListNode<T> getPrev() {
		return this.prev;
	}
	
	public void setPrev(ListNode<T> prev) {
		this.prev = prev;
	}
	
	public ListNode<T> getNext() {
		return this.next;
	}
	
	public void setNext(ListNode<T> next) {
		this.next = next;
	}
	
	public T getValue() {
		return this.value;
	}
	
	public void setValue(T value) {
		this.value = value;
	}
	
	/**
	 * Check that the prev and next pointers are valid
	 * @return
	 */
	public boolean validLinks() {
		if(getNext() == null || getPrev() == null) {
			return false;
		} else if(getNext().getPrev() != this) {
			return false;
		} else if(getPrev().getNext() != this) {
			return false;
		} else {
			return true;
		}		
	}

}
