/**
 * COMP 401 Fall 2017 -- Recitation 10 November 2017
 * 
 * Copyright (C) 2017, Alex Blate. All Rights Reserved.
 */
package recitations.recitation11;

import java.util.Collection;

public interface SimpleQueue<T> {

	/**
	  * Element e is added to the tail/end of the queue
	  * @param e
	  */
	void enqueue(T e);

	/**
	  * The first element in the queue is dequeued and returned.
	  * @return
	  */
	T dequeue();

	/** 
	  * @return the value of the first element in the queue. The queue is not modified.
	  */
	T head();

	int size();

	boolean isEmpty();

	void clear();

	/**
	  * Add the contents of elements to the queue. The
	  * elements are pushed onto the queue in sequential order.
	  *  
	  * @param elements
	  */
	void enqueueAll(T[] elements);
	
	<C extends Collection<T>> void enqueueAll(C coll);

}
