/**
 * COMP 401 Fall 2017 -- Recitation 10 November 2017
 * 
 * Copyright (C) 2017, Alex Blate. All Rights Reserved.
 */
package recitations.recitation11;


public class TestSimpleQueue {

	public static void main(String[] args) {
		SimpleQueue<String> queue = new LinkedQueue<>();


		doQueueTest(queue);

		queue = new DropTailBoundedQueue<>(3);
		System.out.println();


		doQueueTest(queue);

	}

	protected static void doQueueTest(SimpleQueue<String> queue) {
		System.out.println("Testing for " + queue.getClass().getName());
		System.out.println(queue.toString());
		
		String[] names = {"Alice" , "Bob", "Cathy","Mike","Nina"};
		for(String name:names) {
			queue.enqueue(name);
			System.out.println(queue.toString());
		}

		while (!queue.isEmpty()) {
			System.out.println("queue.pop() = " + queue.dequeue().toString());
			System.out.println(queue.toString());
		}
		
		try {
			System.out.println("queue.pop() = " + queue.dequeue().toString());
			System.out.println(queue.toString());
		} catch(Exception ex) {
			System.out.println("Queue does not support pop on empty queue: " + ex.getMessage());
		}

		try {
			queue.enqueue(null);
			System.out.println(queue.toString());
		} catch (RuntimeException ex) {
			System.out.println("Queue does not support enqueueing null: " + ex.getMessage());
		}

		//What happens if queue instanceof DropTailBoundedQueue and I add
		//the element null to the array below?
		String[] moreNames = { "Dave", "Elaine", "Fred", "Gabby" };
		queue.enqueueAll(moreNames);
		System.out.println(queue.toString());
		queue.clear();
		System.out.println(queue.toString());
	}

}
