package recitations.recitation11.generics;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class GenericMethods {
	
	//Single parameter
	public static <T> boolean allNonNull(T[] array) {
		if(array==null) {
			return true;
		}
		
		for(T a: array) {
			if(null == a) {
				return false;
			}
		}
		
		return true;
	}
	
	//Multiple parameters
	public static <T,U> List<GeneralPair<T,U>> toPairs(T[] ts, U[] us) {
		//Ignore sanity-check of inputs
		List<GeneralPair<T,U>> res = new ArrayList<GeneralPair<T,U>>(ts.length);
		for(int i=0; i<ts.length; i++) {
			res.add(new GeneralPair<T, U>(ts[i],us[i]));
		}
		
		return res;
	}
	
	//Bounded type parameter
	public static <T extends Collection<String>> String concat(T coll) {
		StringBuilder res = new StringBuilder(coll.size());
		for(String s:coll) {
			res.append(s);
		}
		
		return res.toString();
	}
	
	//Bounded type parameter, multiple parameters
	public static <T extends Comparable<T>, U extends Collection<T>> void addIfLargest(T element, U coll) {
		
		for(T elt : coll) {
			if(element.compareTo(elt)<0) {
				return;
			}
		}
		
		coll.add(element);
	}
	
	//Wildcard parameter
	public static boolean evenNumElements(List<?> list) {
		return (list.size() % 2) == 0;
	}
	
	//Silly example of bounded wildcard
	public static boolean firstTwoSorted(List<? extends Number> list) {
		if(list.size() < 2) { 
			return false;
		} else {
			return list.get(0).doubleValue() <= list.get(1).doubleValue();
		}
	}
	

}